/****************************************************************************
**
** Copyright (C) 1992-2005 Trolltech AS. All rights reserved.
**
** This file is part of the QtGui module of the Qt Toolkit.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QFILTERINGPROXYMODEL_H
#define QFILTERINGPROXYMODEL_H

#include <QtGui/qmappingproxymodel.h>

QT_MODULE(Gui)

class QFilteringProxyModelPrivate;

class Q_GUI_EXPORT QFilteringProxyModel : public QMappingProxyModel
{
    Q_OBJECT

public:
    QFilteringProxyModel(QObject *parent = 0);
    ~QFilteringProxyModel();

    void clear();

    QModelIndex index(int row, int column, const QModelIndex &parent) const;
    int rowCount(const QModelIndex &parent) const;
    int columnCount(const QModelIndex &parent) const;

protected:
    QFilteringProxyModel(QFilteringProxyModelPrivate &, QObject *parent);
    virtual bool filterRow(int source_row, const QModelIndex &source_parent) const;
    virtual bool filterColumn(int source_column, const QModelIndex &source_parent) const;
    virtual void mapChildren(const QModelIndex &parent) const;
    void sourceLayoutChanged();

private:
    Q_DECLARE_PRIVATE(QFilteringProxyModel)
    Q_DISABLE_COPY(QFilteringProxyModel)
};

#endif // QFILTERINGPROXYMODEL_H
